
#include "StdAfx.h"
#include "AbstractSyntaxColorer.h"
#include "CCrystalEditView.h"

AbstractSyntaxColorer::AbstractSyntaxColorer()
{
	defaultTextColor = ::GetSysColor(COLOR_WINDOWTEXT);
	defaultBkColor = ::GetSysColor(COLOR_WINDOW);
	noTextColor = defaultBkColor;
	endMarkColor = defaultBkColor;
	selectTextColor = defaultBkColor;
	selectBkColor = defaultTextColor;
	endMarkColumn = 0;
}

void AbstractSyntaxColorer::color(int begin, int end, COLORREF crText, COLORREF crBK)
{
	_view->DrawLineHelper(begin, end, crText, crBK);
}

void AbstractSyntaxColorer::startColor(int begin, COLORREF crText, COLORREF crBK)
{
	if (_activeColorRange)
		endColor(begin);
	_activeColorRange = true;
	_begin = begin;
	_crText = crText;
	_crBK = crBK;
}

void AbstractSyntaxColorer::endColor(int end)
{
	if (!_activeColorRange)
		return;

	color(_begin, end, _crText, _crBK);
	_activeColorRange = false;
}

void AbstractSyntaxColorer::drawLine(LPCTSTR line, DWORD &state, int &lineFlags)
{
	if (state == 0)
		state = createParseState();
	else
		state = copyParseState(state);
	_activeColorRange = false;
	parseLine(line, state, lineFlags);
	if (_activeColorRange)
		endColor(strlen(line));
}


