// SampleImageView.cpp : implementation of the CSampleImageView class
//

#include "stdafx.h"
#include "Sample.h"

#include "SampleImageDoc.h"
#include "SampleImageView.h"
#include "editcmd.h"
#include <math.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CSampleImageView

IMPLEMENT_DYNCREATE(CSampleImageView, CView)

HINSTANCE CSampleImageView::s_hResourceInst = NULL;

BEGIN_MESSAGE_MAP(CSampleImageView, CView)
	//{{AFX_MSG_MAP(CSampleImageView)
	ON_WM_CREATE()
	ON_WM_DESTROY()
	ON_WM_ERASEBKGND()
	ON_WM_SIZE()
	ON_WM_VSCROLL()
	ON_WM_HSCROLL()
	ON_WM_CONTEXTMENU()
	ON_WM_CHAR()
	ON_WM_MOUSEMOVE()
	ON_WM_LBUTTONDOWN()
	ON_WM_LBUTTONUP()
	ON_COMMAND(ID_EDIT_COPY, OnEditCopy)
	ON_UPDATE_COMMAND_UI(ID_EDIT_UNDO, OnUpdateEditUndo)
	ON_COMMAND(ID_EDIT_UNDO, OnEditUndo)
	ON_UPDATE_COMMAND_UI(ID_EDIT_REDO, OnUpdateEditRedo)
	ON_COMMAND(ID_EDIT_REDO, OnEditRedo)
	//}}AFX_MSG_MAP
	// Standard printing commands
	ON_COMMAND(ID_FILE_PRINT, CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_DIRECT, CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_PREVIEW, CView::OnFilePrintPreview)
	// Syntax colorer
	ON_COMMAND(ID_VIEW_COLORER_CPP, OnSelectCppColorer)
	ON_COMMAND(ID_VIEW_COLORER_CDF, OnSelectCDFColorer)
	ON_COMMAND(ID_VIEW_COLORER_HTML, OnSelectHTMLColorer)
	ON_COMMAND(ID_VIEW_COLORER_XML, OnSelectXMLColorer)
	ON_COMMAND(ID_VIEW_COLORER_JAVASCRIPT, OnSelectJavaScriptColorer)
	ON_COMMAND(ID_VIEW_COLORER_CVB, OnSelectcvbColorer)
	ON_COMMAND(ID_VIEW_COLORER_SCR, OnSelectCppColorer)
	ON_COMMAND(ID_VIEW_COLORER_NONE, OnSelectNoColorer)
	//	Status
	//ON_UPDATE_COMMAND_UI(ID_EDIT_INDICATOR_CRLF, OnUpdateIndicatorCRLF)
	ON_UPDATE_COMMAND_UI(ID_EDIT_INDICATOR_POSITION, OnUpdateIndicatorPosition)
	ON_UPDATE_COMMAND_UI(ID_EDIT_INDICATOR_COL, OnUpdateIndicatorCol)
	ON_COMMAND(ID_EDIT_CHAR_LEFT, OnCharLeft)
	ON_COMMAND(ID_EDIT_EXT_CHAR_LEFT, OnExtCharLeft)
	ON_COMMAND(ID_EDIT_CHAR_RIGHT, OnCharRight)
	ON_COMMAND(ID_EDIT_EXT_CHAR_RIGHT, OnExtCharRight)
	ON_COMMAND(ID_EDIT_LINE_UP, OnLineUp)
	ON_COMMAND(ID_EDIT_EXT_LINE_UP, OnExtLineUp)
	ON_COMMAND(ID_EDIT_LINE_DOWN, OnLineDown)
	ON_COMMAND(ID_EDIT_EXT_LINE_DOWN, OnExtLineDown)
END_MESSAGE_MAP()

#define EXPAND_PRIMITIVE(impl, func)	\
	void CSampleImageView::On##func() { impl(FALSE); }	\
	void CSampleImageView::OnExt##func() { impl(TRUE); }
	EXPAND_PRIMITIVE(MoveLeft, CharLeft)
	EXPAND_PRIMITIVE(MoveRight, CharRight)
	EXPAND_PRIMITIVE(MoveUp, LineUp)
	EXPAND_PRIMITIVE(MoveDown, LineDown)
#undef EXPAND_PRIMITIVE

/////////////////////////////////////////////////////////////////////////////
// CSampleImageView construction/destruction

CSampleImageView::CSampleImageView()
{
	AFX_ZERO_INIT_OBJECT(CView);
	m_nMagnification = 1;
}

CSampleImageView::~CSampleImageView()
{
	ASSERT(m_pCacheBitmap == NULL);
}

HINSTANCE CSampleImageView::GetResourceHandle()
{
#ifdef CRYSEDIT_RES_HANDLE
	return CRYSEDIT_RES_HANDLE;
#else
	if (s_hResourceInst != NULL)
		return s_hResourceInst;
	return AfxGetResourceHandle();
#endif
}

int CSampleImageView::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
	if (CView::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	ASSERT(m_hAccel == NULL);
	m_hAccel = ::LoadAccelerators(AfxGetResourceHandle(), MAKEINTRESOURCE(IDR_IMAGE_ACCEL));
	ASSERT(m_hAccel != NULL);
	return 0;
}

BOOL CSampleImageView::PreTranslateMessage(MSG *pMsg) 
{
	if (pMsg->message >= WM_KEYFIRST && pMsg->message <= WM_KEYLAST)
	{
		if (m_hAccel != NULL)
		{
			if (::TranslateAccelerator(m_hWnd, m_hAccel, pMsg))
				return TRUE;
		}
	}

	return CView::PreTranslateMessage(pMsg);
}

BOOL CSampleImageView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return CView::PreCreateWindow(cs);
}


/////////////////////////////////////////////////////////////////////////////
// CSampleImageView diagnostics

#ifdef _DEBUG
void CSampleImageView::AssertValid() const
{
	CView::AssertValid();
}

void CSampleImageView::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}

CSampleImageDoc* CSampleImageView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CSampleImageDoc)));
	return (CSampleImageDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CSampleImageView message handlers

void CSampleImageView::OnDestroy() 
{
	CView::OnDestroy();

	if (m_pCacheBitmap != NULL)
	{
		m_pCacheBitmap->DeleteObject();
		delete m_pCacheBitmap;
		m_pCacheBitmap = NULL;
	}
}

BOOL CSampleImageView::OnEraseBkgnd(CDC *pdc) 
{
	return TRUE;
}

void CSampleImageView::OnInitialUpdate() 
{
	CView::OnInitialUpdate();

	//	Update scrollbars
	RecalcVertScrollBar();
	RecalcHorzScrollBar();
}

void CSampleImageView::OnSetFileName(LPCTSTR lpszPathName)
{
	const char *ext;
	for (ext = lpszPathName + strlen(lpszPathName); ext > lpszPathName && ext[-1] != '.'; ext--);
}

void CSampleImageView::OnContextMenu(CWnd* pWnd, CPoint point) 
{
	//AfxMessageBox("Build your own context menu!");
}

void CSampleImageView::OnDraw(CDC *pDC)
{
	if ( GetDocument() == 0 || pDC == 0){
		ASSERT( 0 );
		return;
	}

	CRect rcClient;
	GetClientRect( &rcClient );
	CRect clippingRect (0, 0, 0, 0);
	if (pDC->GetClipBox(&clippingRect) == NULLREGION)
		clippingRect = rcClient;

	//clippingRect.InflateRect( 1, 1 );
 
	CDC cacheDC;
	VERIFY(cacheDC.CreateCompatibleDC(pDC));
	if (m_pCacheBitmap == NULL)
	{
		m_pCacheBitmap = new CBitmap;
		VERIFY(m_pCacheBitmap->CreateCompatibleBitmap(pDC, rcClient.Width(), rcClient.Height()));
	}
	CBitmap *pOldBitmap = cacheDC.SelectObject(m_pCacheBitmap);

	cacheDC.FillSolidRect(rcClient, RGB(128, 128, 128)); //pDC->GetBkColor());

	m_nXoffset = 0;
	int nImageWidth = GetImageWidth();
	int nExtraWidth = rcClient.Width() - nImageWidth;
	if (m_nLeftX == 0 && nExtraWidth > 0)
		m_nXoffset = nExtraWidth/2;

	m_nYoffset = 0;
	int nImageHeight = GetImageHeight();
	int nExtraHeight = rcClient.Height() - nImageHeight;
	if (m_nTopY == 0 && nExtraHeight > 0)
		m_nYoffset = nExtraHeight/2;

	GetDocument()->m_gflBitmap.drawImageStretch( cacheDC,
		m_nXoffset, m_nYoffset, nImageWidth, nImageHeight, 
		m_nLeftX / m_nMagnification, -m_nTopY / m_nMagnification ); 
		
	
	VERIFY(pDC->BitBlt(rcClient.left, rcClient.top, rcClient.Width(), rcClient.Height(),
					   &cacheDC, rcClient.left, rcClient.top, SRCCOPY));
	cacheDC.SelectObject(pOldBitmap);
	cacheDC.DeleteDC();

}


void CSampleImageView::RecalcVertScrollBar(BOOL bPositionOnly /*= FALSE*/)
{
	SCROLLINFO si;
	si.cbSize = sizeof(si);
	if (bPositionOnly)
	{
		si.fMask = SIF_POS;
		si.nPos = m_nTopY;
	}
	else
	{
		if (GetScreenHeight() >= GetImageHeight() && m_nTopY > 0)
		{
			m_nTopY = 0;
			Invalidate();
		}
		si.fMask = SIF_DISABLENOSCROLL | SIF_PAGE | SIF_POS | SIF_RANGE;
		si.nMin = 0;
		si.nMax = GetImageHeight() - 1;
		si.nPage = GetScreenHeight();
		si.nPos = m_nTopY;
	}
	VERIFY(SetScrollInfo(SB_VERT, &si));
}

void CSampleImageView::OnVScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar) 
{
	CView::OnVScroll(nSBCode, nPos, pScrollBar);

	//	Note we cannot use nPos because of its 16-bit nature
	SCROLLINFO si;
	si.cbSize = sizeof(si);
	si.fMask = SIF_ALL;
	VERIFY(GetScrollInfo(SB_VERT, &si));

	int nImageHeight = GetImageHeight();

	int nNewTopY;
	BOOL bDisableSmooth = TRUE;
	switch (nSBCode)
	{
	case SB_TOP:
		nNewTopY = 0;
		bDisableSmooth = FALSE;
		break;
	case SB_BOTTOM:
		nNewTopY = m_nTopY - GetScreenHeight() + 1;
		bDisableSmooth = FALSE;
		break;
	case SB_LINEUP:
		nNewTopY = m_nTopY - m_nMagnification*8;
		break;
	case SB_LINEDOWN:
		nNewTopY = m_nTopY + m_nMagnification*8;
		break;
	case SB_PAGEUP:
		nNewTopY = m_nTopY - si.nPage + 1;
		bDisableSmooth = FALSE;
		break;
	case SB_PAGEDOWN:
		nNewTopY = m_nTopY + si.nPage - 1;
		bDisableSmooth = FALSE;
		break;
	case SB_THUMBPOSITION:
	case SB_THUMBTRACK:
		nNewTopY = si.nTrackPos;
		break;
	default:
		return;
	}

	VertScrollTo(nNewTopY);
}

long CSampleImageView::NormalizeY(long nY)
{
	int nImageHeight = GetImageHeight();

	if (nY < 0)
		nY = 0;
	if (nY >= nImageHeight)
		nY = nImageHeight - 1;
	// Round to nearest multiple of m_nMagnification
	return ((nY + m_nMagnification/2) / m_nMagnification) * m_nMagnification;
}

void CSampleImageView::VertScrollTo(long nNewTopY)
{
	nNewTopY = NormalizeY(nNewTopY);

	if (m_nTopY != nNewTopY)
	{
		m_nTopY = nNewTopY;
		Invalidate();
		RecalcVertScrollBar(TRUE);
	}
}

void CSampleImageView::RecalcHorzScrollBar(BOOL bPositionOnly /*= FALSE*/)
{
	//	Again, we cannot use nPos because it's 16-bit
	SCROLLINFO si;
	si.cbSize = sizeof(si);
	if (bPositionOnly)
	{
		si.fMask = SIF_POS;
		si.nPos = m_nLeftX;
	}
	else
	{
		if (GetScreenWidth() >= GetImageWidth() && m_nLeftX > 0)
		{
			m_nLeftX = 0;
			Invalidate();
			//UpdateCaret();
		}
		si.fMask = SIF_DISABLENOSCROLL | SIF_PAGE | SIF_POS | SIF_RANGE;
		si.nMin = 0;
		si.nMax = GetImageWidth() - 1;
		si.nPage = GetScreenWidth();
		si.nPos = m_nLeftX;
	}
	VERIFY(SetScrollInfo(SB_HORZ, &si));
}

void CSampleImageView::OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar) 
{
	CView::OnHScroll(nSBCode, nPos, pScrollBar);

	SCROLLINFO si;
	si.cbSize = sizeof(si);
	si.fMask = SIF_ALL;
	VERIFY(GetScrollInfo(SB_HORZ, &si));

	int nImageWidth = GetImageWidth();

	int nNewLeftX;
	switch (nSBCode)
	{
	case SB_LEFT:
		nNewLeftX = 0;
		break;
	case SB_RIGHT:
		nNewLeftX = nImageWidth - GetScreenWidth() + 1;
		break;
	case SB_LINEUP:
		nNewLeftX = m_nLeftX - m_nMagnification*8;
		break;
	case SB_LINEDOWN:
		nNewLeftX = m_nLeftX + m_nMagnification*8;
		break;
	case SB_PAGEUP:
		nNewLeftX = m_nLeftX - si.nPage + 1;
		break;
	case SB_PAGEDOWN:
		nNewLeftX = m_nLeftX + si.nPage - 1;
		break;
	case SB_THUMBPOSITION:
	case SB_THUMBTRACK:
		nNewLeftX = si.nTrackPos;
		break;
	default:
		return;
	}

	HorzScrollTo(nNewLeftX);
}

long CSampleImageView::NormalizeX(long nX)
{
	int nImageWidth = GetImageWidth();

	if (nX < 0)
		nX = 0;
	if (nX >= nImageWidth)
		nX = nImageWidth - 1;
	// Round to nearest multiple of m_nMagnification
	return ((nX + m_nMagnification/2) / m_nMagnification) * m_nMagnification;
}

void CSampleImageView::HorzScrollTo(long nNewLeftX)
{
	nNewLeftX = NormalizeX(nNewLeftX);

	if (m_nLeftX != nNewLeftX)
	{
		m_nLeftX = nNewLeftX;
		Invalidate();
		RecalcHorzScrollBar(TRUE);
	}
}

void CSampleImageView::OnSize(UINT nType, int cx, int cy) 
{
	CView::OnSize(nType, cx, cy);

	if (m_pCacheBitmap != NULL)
	{
		m_pCacheBitmap->DeleteObject();
		delete m_pCacheBitmap;
		m_pCacheBitmap = NULL;
	}
	m_nScreenWidth = -1;
	m_nScreenHeight = -1;
	RecalcVertScrollBar();
	RecalcHorzScrollBar();
}

bool CSampleImageView::GetXY(int& x, int& y)
{
	x = (m_nLeftX + m_ptMousePos.x - m_nXoffset - 1)/m_nMagnification;
	y = (m_nTopY + m_ptMousePos.y - m_nYoffset - 1)/m_nMagnification;
	GFLBitmap& bitmap = GetDocument()->m_gflBitmap;

	TRACE1("m_nTopY = %d ", m_nTopY);
	TRACE1("mousepos.y = %d ", m_ptMousePos.y);
	TRACE1("m_nYoffset = %d ", m_nYoffset);
	TRACE1("m_nMagnification = %d ", m_nMagnification);
	TRACE1("y = %d ", y);
	TRACE1("bitmap.height = %d\n", bitmap.height());
	return    0 <= x && x < bitmap.width()
		   && 0 <= y && y < bitmap.height();
}

bool CSampleImageView::GetXY(double& x, double& y)
{
	x = (m_nLeftX + m_ptMousePos.x - m_nXoffset - 1)/(double)m_nMagnification;
	y = (m_nTopY + m_ptMousePos.y - m_nYoffset - 1)/(double)m_nMagnification;
	GFLBitmap& bitmap = GetDocument()->m_gflBitmap;

	TRACE1("m_nTopY = %d ", m_nTopY);
	TRACE1("mousepos.y = %d ", m_ptMousePos.y);
	TRACE1("m_nYoffset = %d ", m_nYoffset);
	TRACE1("m_nMagnification = %d ", m_nMagnification);
	TRACE1("y = %lf ", y);
	TRACE1("bitmap.height = %d\n", bitmap.height());
	return    0.0 <= x && x < (double)bitmap.width()
		   && 0.0 <= y && y < (double)bitmap.height();
}

void CSampleImageView::OnUpdateIndicatorPosition(CCmdUI* pCmdUI)
{
	int x, y;
	CString stat;
	if (GetXY(x, y))
		stat.Format(_T("%d, %d"), x+1, y+1);
	pCmdUI->SetText(stat);
}

void CSampleImageView::OnUpdateIndicatorCol(CCmdUI* pCmdUI)
{
	pCmdUI->Enable(TRUE);

	int x, y;
	CString stat;
	if (GetXY(x, y))
	{
		GFLBitmap& bitmap = GetDocument()->m_gflBitmap;
		double r, g, b;
		if (bitmap.getInterpolatedColor(x, y, r, g, b))
			stat.Format(_T("%d,%d,%d"), (int)floor(r), (int)floor(g), (int)floor(b));
	}
	pCmdUI->SetText(stat);
}

void CSampleImageView::OnMouseMove(UINT nFlags, CPoint point) 
{
	CView::OnMouseMove(nFlags, point);

	m_ptMousePos = point;
	if (_drawState == 'C')
		if (nFlags & MK_LBUTTON)
		{
			int x,y;
			if (GetXY(x, y))
			{
				GFLBitmap& bitmap = GetDocument()->m_gflBitmap;
				bitmap.setColor(x, y, _colorRed, _colorGreen, _colorBlue);
				Invalidate();
			}
		}
		else
			_drawState = 'c';
}

void CSampleImageView::OnLButtonDown(UINT nFlags, CPoint point)
{
	m_ptMousePos = point;
	if (_drawState == 'c')
	{
		_drawState = 'C';
		int x,y;
		if (GetXY(x, y))
		{
			GFLBitmap& bitmap = GetDocument()->m_gflBitmap;
			bitmap.setColor(x, y, _colorRed, _colorGreen, _colorBlue);
			Invalidate();
		}
	}
}

void CSampleImageView::OnLButtonUp(UINT nFlags, CPoint point)
{
	m_ptMousePos = point;
	if (_drawState == 'C')
		_drawState = 'c';
}

int CSampleImageView::GetScreenWidth()
{
	if (m_nScreenWidth == -1)
	{
		CRect rect;
		GetClientRect(&rect);
		m_nScreenWidth = rect.Width();
	}
	return m_nScreenWidth;
}

int CSampleImageView::GetScreenHeight()
{
	if (m_nScreenHeight == -1)
	{
		CRect rect;
		GetClientRect(&rect);
		m_nScreenHeight = rect.Height();
	}
	return m_nScreenHeight;
}

int CSampleImageView::GetImageWidth()
{
	return GetDocument()->m_gflBitmap.width() * m_nMagnification;
}

int CSampleImageView::GetImageHeight()
{
	return GetDocument()->m_gflBitmap.height() * m_nMagnification;
}

void CSampleImageView::OnChar(UINT nChar, UINT nRepCnt, UINT nFlags) 
{
	CView::OnChar(nChar, nRepCnt, nFlags);

	int i = 0;
	switch(nChar)
	{
		case '+':
			if (m_nMagnification < 16)
			{
				m_nMagnification *= 2;

				int screenWidth = GetScreenWidth();
				int imageWidth = GetImageWidth();
				if (imageWidth < screenWidth)
				{
					m_nLeftX = 0;
					m_nXoffset = (screenWidth - imageWidth) / 2;
				}
				else
				{
					int x = (m_nLeftX + screenWidth/2 - m_nXoffset)*2 - screenWidth/2;
					if (x < 0)
						x = 0;
					m_nLeftX = NormalizeX(x);
					m_nXoffset = 0;
				}

				int screenHeight = GetScreenHeight();
				int imageHeight = GetImageHeight();
				if (imageHeight < screenHeight)
				{
					m_nTopY = 0;
					m_nYoffset = (screenHeight - imageHeight) / 2;
				}
				else
				{
					int y = (m_nTopY + screenHeight/2 - m_nYoffset)*2 - screenHeight/2;
					if (y < 0)
						y = 0;
					m_nTopY = NormalizeY(y);
					m_nYoffset = 0;
				}

				RecalcVertScrollBar();
				RecalcHorzScrollBar();
				Invalidate();
			}
			break;
		case '-':
			if (m_nMagnification > 1)
			{
				m_nMagnification /= 2;
				int screenWidth = GetScreenWidth();
				int imageWidth = GetImageWidth();
				if (imageWidth < screenWidth)
				{
					m_nLeftX = 0;
					m_nXoffset = (screenWidth - imageWidth) / 2;
				}
				else
				{
					int x = (m_nLeftX + screenWidth/2 - m_nXoffset)/2 - screenWidth/2;
					if (x < 0)
						x = 0;
					m_nLeftX = NormalizeX(x);
					m_nXoffset = 0;
				}

				int screenHeight = GetScreenHeight();
				int imageHeight = GetImageHeight();
				if (imageHeight < screenHeight)
				{
					m_nTopY = 0;
					m_nYoffset = (screenHeight - imageHeight) / 2;
				}
				else
				{
					int y = (m_nTopY + screenHeight/2 - m_nYoffset)/2 - screenHeight/2;
					if (y < 0)
						y = 0;
					m_nTopY = NormalizeY(y);
					m_nYoffset = 0;
				}

				RecalcVertScrollBar();
				RecalcHorzScrollBar();
				Invalidate();
			}
			break;
		case 'c':
			{
				int x,y;
				if (GetXY(x, y))
				{
					GFLBitmap& bitmap = GetDocument()->m_gflBitmap;
					double r, g, b;
					if (bitmap.getInterpolatedColor(x, y, r, g, b))
					{
						_colorRed = (int)floor(r + 0.5);
						_colorGreen = (int)floor(g + 0.5);
						_colorBlue = (int)floor(b + 0.5);
						_drawState = 'c';
					}
				}
			}
			break;
		case '9': i++;
		case '8': i++;
		case '7': i++;
		case '6': i++;
		case '5': i++;
		case '4': i++;
		case '3': i++;
		case '2': i++;
		case '1':
			{
				CSampleImageDoc* document = GetDocument();
				document->m_points[i].valid = GetXY(document->m_points[i].x, document->m_points[i].y);
			}
	}
	
}

void CSampleImageView::OnSelectCppColorer()
{
}

void CSampleImageView::OnSelectCDFColorer()
{
}

void CSampleImageView::OnSelectHTMLColorer()
{
}

void CSampleImageView::OnSelectXMLColorer()
{
}

void CSampleImageView::OnSelectJavaScriptColorer()
{
}

void CSampleImageView::OnSelectcvbColorer()
{
}

void CSampleImageView::OnSelectNoColorer()
{
}

void CSampleImageView::OnSelectScrColorer()
{
}

void CSampleImageView::MoveLeft(BOOL bShift)
{
	HorzScrollTo(m_nLeftX - m_nMagnification*(bShift ? 50 : 10));
}

void CSampleImageView::MoveRight(BOOL bShift)
{
	HorzScrollTo(m_nLeftX + m_nMagnification*(bShift ? 50 : 10));
}

void CSampleImageView::MoveUp(BOOL bShift)
{
	VertScrollTo(m_nTopY - m_nMagnification*(bShift ? 50 : 10));
}

void CSampleImageView::MoveDown(BOOL bShift)
{
	VertScrollTo(m_nTopY + m_nMagnification*(bShift ? 50 : 10));
}

void CSampleImageView::OnEditCopy()
{
	int x,y;
	if (!GetXY(x, y))
		return;
	GFLBitmap& bitmap = GetDocument()->m_gflBitmap;
	double r, g, b;
	if (!bitmap.getInterpolatedColor(x, y, r, g, b))
		return;
	_colorRed = (int)floor(r + 0.5);
	_colorGreen = (int)floor(g + 0.5);
	_colorBlue = (int)floor(b + 0.5);
	_drawState = 'c';
	CString text;
	text.Format(_T("%d %d %d %d %d"), x, y, _colorRed, _colorBlue, _colorBlue);
	LPCTSTR pszText = text;
	CWaitCursor wc;
	BOOL bOK = FALSE;
	if (!OpenClipboard())
		return;
	EmptyClipboard();
	HGLOBAL hData = GlobalAlloc(GMEM_MOVEABLE | GMEM_DDESHARE, lstrlen(pszText) + 1);
	if (hData != NULL)
	{
		LPSTR pszData = (LPSTR) ::GlobalLock(hData);
		USES_CONVERSION;
		strcpy(pszData, T2A((LPTSTR) pszText));
		GlobalUnlock(hData);
		bOK = SetClipboardData(CF_TEXT, hData) != NULL;
	}
	CloseClipboard();
}

void CSampleImageView::OnUpdateEditUndo(CCmdUI* pCmdUI) 
{
	GFLBitmap& bitmap = GetDocument()->m_gflBitmap;
	BOOL bCanUndo = bitmap.CanUndo();
	pCmdUI->Enable(bCanUndo);

	//	Since we need text only for menus...
	if (pCmdUI->m_pMenu != NULL)
	{
		//	Tune up 'resource handle'
		HINSTANCE hOldResHandle = AfxGetResourceHandle();
		AfxSetResourceHandle(GetResourceHandle());

		CString menu;
		if (bCanUndo)
		{
			//	Format menu item text using the provided item description
			menu.Format(IDS_MENU_UNDO_FORMAT, _T("Pixel"));
		}
		else
		{
			//	Just load default menu item text
			menu.LoadString(IDS_MENU_UNDO_DEFAULT);
		}

		//	Restore original handle
		AfxSetResourceHandle(hOldResHandle);

		//	Set menu item text
		pCmdUI->SetText(menu);
	}
}

void CSampleImageView::OnEditUndo() 
{
	GFLBitmap& bitmap = GetDocument()->m_gflBitmap;
	if (bitmap.Undo())
	{
		Invalidate();
	}
}

void CSampleImageView::OnEditRedo() 
{
	GFLBitmap& bitmap = GetDocument()->m_gflBitmap;
	if (bitmap.Redo())
	{
		Invalidate();
	}
}

void CSampleImageView::OnUpdateEditRedo(CCmdUI* pCmdUI) 
{
	GFLBitmap& bitmap = GetDocument()->m_gflBitmap;
	BOOL bCanRedo = bitmap.CanRedo();
	pCmdUI->Enable(bCanRedo);

	//	Since we need text only for menus...
	if (pCmdUI->m_pMenu != NULL)
	{
		//	Tune up 'resource handle'
		HINSTANCE hOldResHandle = AfxGetResourceHandle();
		AfxSetResourceHandle(GetResourceHandle());

		CString menu;
		if (bCanRedo)
		{
			menu.Format(IDS_MENU_REDO_FORMAT, _T("Pixel"));
		}
		else
		{
			//	Just load default menu item text
			menu.LoadString(IDS_MENU_REDO_DEFAULT);
		}

		//	Restore original handle
		AfxSetResourceHandle(hOldResHandle);

		//	Set menu item text
		pCmdUI->SetText(menu);
	}
}

