// SampleImageView.h : interface of the CSampleImageView class
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_SAMPLEIMAGEVIEW_H__INCLUDED_)
#define AFX_SAMPLEIMAGEVIEW_H__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

class CSampleImageDoc;

class CSampleImageView : public CView
{
protected: // create from serialization only
	CSampleImageView();
	DECLARE_DYNCREATE(CSampleImageView)

	virtual HINSTANCE GetResourceHandle();

// Attributes
public:
	CSampleImageDoc* GetDocument();

	//	Default handle to resources
	static HINSTANCE s_hResourceInst;

	void OnSetFileName(LPCTSTR lpszPathName);

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CSampleImageView)
	public:
	virtual void OnDraw(CDC* pDC);  // overridden to draw this view
	virtual BOOL PreTranslateMessage(MSG* pMsg);
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	virtual void OnInitialUpdate();
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CSampleImageView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:
	//	Keyboard handlers
	void MoveLeft(BOOL bShift);
	void MoveRight(BOOL bShift);
	void MoveUp(BOOL bShift);
	void MoveDown(BOOL bShift);

	int m_nScreenHeight;
	int m_nScreenWidth;
	int m_nTopY, m_nLeftX;
	int m_nMagnification;
	int m_nXoffset, m_nYoffset;
	CPoint m_ptMousePos;
	int GetScreenWidth();
	int GetScreenHeight();
	int GetImageHeight();
	int GetImageWidth();

	void RecalcVertScrollBar(BOOL bPositionOnly = FALSE);
	long NormalizeY(long nY);
	void VertScrollTo(long nNewTopY);
	void RecalcHorzScrollBar(BOOL bPositionOnly = FALSE);
	long NormalizeX(long nX);
	void HorzScrollTo(long nNewLeftX);

	bool GetXY(int& x, int& y);
	bool GetXY(double& x, double& y);

private:
	//	Painting caching bitmap
	HACCEL m_hAccel;
	CBitmap *m_pCacheBitmap;

	char _drawState;
	int _colorRed;
	int _colorGreen;
	int _colorBlue;

// Generated message map functions
protected:
	//{{AFX_MSG(CSampleImageView)
	afx_msg void OnDestroy();
	afx_msg BOOL OnEraseBkgnd(CDC* pDC);
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg void OnContextMenu(CWnd* pWnd, CPoint point);
	afx_msg void OnChar(UINT nChar, UINT nRepCnt, UINT nFlags);
	afx_msg void OnEditCopy();
	afx_msg void OnMouseMove(UINT nFlags, CPoint point);
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnLButtonUp(UINT nFlags, CPoint point);
	afx_msg void OnSelectCppColorer();
	afx_msg void OnSelectCDFColorer();
	afx_msg void OnSelectHTMLColorer();
	afx_msg void OnSelectXMLColorer();
	afx_msg void OnSelectJavaScriptColorer();
	afx_msg void OnSelectcvbColorer();
	afx_msg void OnSelectScrColorer();
	afx_msg void OnSelectNoColorer();
	afx_msg void OnVScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar);
	afx_msg void OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar);
	afx_msg int  OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg void OnUpdateEditUndo(CCmdUI* pCmdUI);
	afx_msg void OnEditUndo();
	afx_msg void OnUpdateEditRedo(CCmdUI* pCmdUI);
	afx_msg void OnEditRedo();
	//}}AFX_MSG
	afx_msg void OnUpdateIndicatorPosition(CCmdUI* pCmdUI);
	afx_msg void OnUpdateIndicatorCol(CCmdUI* pCmdUI);
	afx_msg void OnCharLeft();
	afx_msg void OnExtCharLeft();
	afx_msg void OnCharRight();
	afx_msg void OnExtCharRight();
	afx_msg void OnLineUp();
	afx_msg void OnExtLineUp();
	afx_msg void OnAltLineUp();
	afx_msg void OnLineDown();
	afx_msg void OnExtLineDown();
	afx_msg void OnAltLineDown();
	DECLARE_MESSAGE_MAP()
};

#ifndef _DEBUG  // debug version in SampleImageView.cpp
inline CSampleImageDoc* CSampleImageView::GetDocument()
   { return (CSampleImageDoc*)m_pDocument; }
#endif

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Developer Studio will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_SAMPLEIMAGEVIEW_H__INCLUDED_)
