#include "StdAfx.h"

#include <string.h>
#include <stdio.h>
#include "TextFileBuffer.h"

#define TAB_POS 4

TextFileBuffer::TextFileBuffer()
{
	_buffer = 0;
}


void TextFileBuffer::assign(const char* str)
{
/*
    int fh = fileno(the_file);
    _file_len = lseek(fh, 0L, SEEK_END);
    lseek(fh, 0L, SEEK_SET);
    _buffer = new char[_file_len+2];
    _file_len = read(fh, _buffer, _file_len);
    _buffer[_file_len] = '\0';
*/
	_buffer = str;
	_len = strlen(str);
	_pos = 0;
	_line = 1;
	_column = 1;
	_info = _buffer;
}

void TextFileBuffer::next()
{
    if (_pos < _len)
    {
      switch(*_info)
      {   case '\t':
              _column = ((_column + TAB_POS) % TAB_POS) * TAB_POS;
              break;
          case '\n':
              _line++;
              _column = 1;
              break;
          default:
              _column++;
              break;
      }
      _pos++;
      _info++;
    }
}

void TextFileBuffer::advance(unsigned int steps)
{
    _pos += steps;
    if (_pos > _len)
        _pos = _len;
    _info = _buffer + _pos;
    _column += steps;
}

void TextFileBuffer::print_state()
{
    printf("[0,%ld,%ld] = `%c'\n", _pos, _len, *_info);
}

const char* TextFileBuffer::start()
{   static char buff[13];
    int i;
    const char *s;

    for (i = 0, s = _info; i < 10 && *s; s++)
        if (*s == '\n')
        {   buff[i++] = '\\';
            buff[i++] = 'n';
        }
        else if (*s == '\t')
        {   buff[i++] = '\\';
            buff[i++] = 't';
        }
        else
            buff[i++] = *s;

    buff[i] = '\0';
    return buff;
}
