#ifndef _INCLUDED_TEXTFILEBUFFER_H
#define _INCLUDED_TEXTFILEBUFFER_H

#include "TextFilePos.h"

class TextFileBuffer : public TextFilePos
{
public:
	TextFileBuffer();

	void assign(const char* str);
	unsigned long length() { return _len; }

	TextFileBuffer& operator=(const TextFilePos& lhs)
	{	
		*(TextFilePos*)this = lhs;
		_info = _buffer + _pos;
		return *this;
	}
	
	inline bool eof() { return _pos >= _len; }
	inline char operator*() { return *_info; }
	inline char operator[](int i) { return _info[i]; }
	inline operator const char*() { return _info; }
	void next();
	void advance(unsigned int steps);

	void print_state();
	const char* start();

private:
	const char *_buffer;
	const char *_info;
	unsigned long _len;
};

#endif // _INCLUDED_TEXTFILEBUFFER_H
